# OptiAI C# SDK
C# SDK for optiAI

This SDK is a C# wrapper around the Optimizely AI API. It is intended to be used by the Optimizely employees to integrate AI features into Optimizely products.

## Accessing the Package
The package is published to the Episerver package repository as Optimizely.OptiGPT.Client.


## Usage
### Set up your Opti AI Instance and Keypair

For development, use the PREP environment. For production, use the PROD environment. The PROD baseURL is `https://cg.optimizely.com`.
Create a turnstile instance and keypair for yourself [here](https://prep.turnstile.episerver.net:8534/Products/Display/e857ce2be15c4c9caa05ad1c233e0c39). You can store and use this from user secrets or from environment variables, depending on your application setup.

### Using the SDK

You can use the client by calling `Create()` and providing your appKey and secretKey, then calling `Complete()` or `Extend()` with your preferred model and your prompt.

```csharp
var optiGPTClient = OptiGPTClient.Create(endpoint, appKey, secretKey);
var models = await optiGPTClient.GetAllModels();

var messages = new[]
{
    new ChatMessage
    {
        Role = "user",
        Content = "Describe a beautiful sunset."
    }
};

var result = await optiGPTClient.Extend(new AIArgs { Model = selectedModel.Name, Messages = messages });
```

## Run Examples

In visual studio, set your startup project to the LocalChat project in the Examples folder and hit run. This will bring up a console window that lets you interact with OptiAI and send prompts.

![image](https://github.com/optimizely/csharp-optiai/assets/10810722/e6d53a51-9598-4d7b-a302-006db17bc149)


## Issues

Log issues directly into GitHub. Pull Requests will be created to resolve those issues as soon as they are triaged.
